Attribute VB_Name = "APIStuff"
Option Explicit

Public OldWindowProc As Long

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const WM_USER = &H400
' Display messages for non-client border and
' button events.
Public Function NewWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Static num As Long

Const WM_NCLBUTTONDOWN = &HA1
Const HTBORDER = 18
Const HTBOTTOM = 15
Const HTBOTTOMLEFT = 16
Const HTBOTTOMRIGHT = 17
Const HTCAPTION = 2
Const HTCLOSE = 20
Const HTGROWBOX = 4
Const HTLEFT = 10
Const HTMAXBUTTON = 9
Const HTMINBUTTON = 8
Const HTRIGHT = 11
Const HTSYSMENU = 3
Const HTTOP = 12
Const HTTOPLEFT = 13
Const HTTOPRIGHT = 14

    If msg = WM_NCLBUTTONDOWN Then
        Select Case wParam
            Case HTBORDER
                Debug.Print Format$(num, "@@@@") & ": (Non-sizable border)"
            Case HTBOTTOM
                Debug.Print Format$(num, "@@@@") & ": (Border, bottom)"
            Case HTBOTTOMLEFT
                Debug.Print Format$(num, "@@@@") & ": (Border, bottom left)"
            Case HTBOTTOMRIGHT
                Debug.Print Format$(num, "@@@@") & ": (Border, bottom right)"
            Case HTGROWBOX
                Debug.Print Format$(num, "@@@@") & ": (Border, grow box)"
            Case HTLEFT
                Debug.Print Format$(num, "@@@@") & ": (Border, left)"
            Case HTRIGHT
                Debug.Print Format$(num, "@@@@") & ": (Border, right)"
            Case HTTOP
                Debug.Print Format$(num, "@@@@") & ": (Border, Top)"
            Case HTTOPLEFT
                Debug.Print Format$(num, "@@@@") & ": (Border, Top left)"
            Case HTTOPRIGHT
                Debug.Print Format$(num, "@@@@") & ": (Border, Top right)"

            Case HTCAPTION
                Debug.Print Format$(num, "@@@@") & ": (Caption)"
            Case HTCLOSE
                Debug.Print Format$(num, "@@@@") & ": (Close)"
            Case HTMAXBUTTON
                Debug.Print Format$(num, "@@@@") & ": (Maximize)"
            Case HTMINBUTTON
                Debug.Print Format$(num, "@@@@") & ": (Minimize)"
            Case HTSYSMENU
                Debug.Print Format$(num, "@@@@") & ": (System menu)"
        End Select
    End If
    num = num + 1

    ' Call the original WindowProc.
    NewWindowProc = CallWindowProc( _
        OldWindowProc, hwnd, msg, wParam, _
        lParam)
End Function
